diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketSignUpdate.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketSignUpdate.java
index 667fec2e6..45d7853c3 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketSignUpdate.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketSignUpdate.java
@@ -34,7 +34,7 @@ public class PacketSignUpdate extends Packet
         signLines = new String[4];
         for(int i = 0; i < 4; i++)
         {
-            signLines[i] = readString(dis, TileEntitySign.MAX_LINE_SIZE);
+            signLines[i] = readStringUTF16BE(dis, TileEntitySign.MAX_LINE_SIZE);
         }
         picture = dis.readInt();
         color = dis.readInt();
@@ -49,7 +49,7 @@ public class PacketSignUpdate extends Packet
         dos.writeInt(zPosition);
         for(int i = 0; i < 4; i++)
         {
-            writeString(signLines[i], dos);
+            writeStringUTF16BE(signLines[i], dos);
         }
         dos.writeInt(picture);
         dos.writeInt(color);
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketStatistic.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketStatistic.java
index 610653289..a71558d9b 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketStatistic.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketStatistic.java
@@ -34,7 +34,7 @@ public class PacketStatistic extends Packet
         throws IOException
     {
         try {
-            statID = new NamespaceID(readString(dis, Integer.MAX_VALUE));
+            statID = new NamespaceID(readStringUTF8(dis, Integer.MAX_VALUE));
         } catch (HardIllegalArgumentException e) {
             statID = null;
         }
@@ -45,7 +45,7 @@ public class PacketStatistic extends Packet
 	public void write(DataOutputStream dos)
         throws IOException
     {
-        writeString(statID.toString(), dos);
+        writeStringUTF8(statID.toString(), dos);
         dos.writeByte(valueChange);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketSyncIDs.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketSyncIDs.java
index 7b3c4b0e9..1504f896e 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketSyncIDs.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketSyncIDs.java
@@ -57,7 +57,7 @@ public class PacketSyncIDs extends Packet {
 		
 		for(int i=0; i < count; i++) {
 			int id = in.readShort() & 0xFFFF;
-			String name = readString(in, MAX_ID_STRING_SIZE);
+			String name = readStringUTF8(in, MAX_ID_STRING_SIZE);
 			mapping.put(id, name);
 		}
 		
@@ -73,7 +73,7 @@ public class PacketSyncIDs extends Packet {
 		
 		for(Entry<Integer, String> entry : mapping.entrySet()) {
 			out.writeShort(entry.getKey());
-			writeString(entry.getValue(), out);
+			writeStringUTF8(entry.getValue(), out);
 		}
 		
 		return bytesWritten;
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketUpdatePlayerProfile.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketUpdatePlayerProfile.java
index b5c348be6..c06bcf8de 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketUpdatePlayerProfile.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketUpdatePlayerProfile.java
@@ -29,8 +29,8 @@ public class PacketUpdatePlayerProfile extends Packet
 	public void read(DataInputStream dis)
             throws IOException
     {
-        username = readString(dis, MAX_USERNAME_SIZE);
-        nickname = readString(dis, MAX_NICKNAME_SIZE);
+        username = readStringUTF8(dis, MAX_USERNAME_SIZE);
+        nickname = readStringUTF16BE(dis, MAX_NICKNAME_SIZE);
         uuid = readUUID(dis);
         score = dis.readInt();
         chatColor = dis.readByte();
@@ -42,8 +42,8 @@ public class PacketUpdatePlayerProfile extends Packet
 	public void write(DataOutputStream dos)
             throws IOException
     {
-        writeString(username, dos);
-        writeString(nickname, dos);
+        writeStringUTF8(username, dos);
+        writeStringUTF16BE(nickname, dos);
         writeUUID(uuid, dos);
         dos.writeInt(score);
         dos.writeByte(chatColor);
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
index 0ac46ab45..8edb31b85 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
@@ -161,7 +161,11 @@ public class MenuInventoryCreative extends MenuInventory
 		{
 			if (Item.itemsList[i] != null && !Item.itemsList[i].hasTag(ItemTags.NOT_IN_CREATIVE_MENU))
 			{
-				creativeItems.add(new ItemStack(Item.itemsList[i]));
+				if (i == Items.PAINTBRUSH.id) {
+					creativeItems.add(new ItemStack(Item.itemsList[i], 1, Items.PAINTBRUSH.getMaxDamage()));
+				} else {
+					creativeItems.add(new ItemStack(Item.itemsList[i]));
+				}
 				count++;
 
 				if (i == Items.COAL.id)
@@ -173,7 +177,7 @@ public class MenuInventoryCreative extends MenuInventory
 					}
 				}
 
-				if (i == Items.DYE.id || i == Items.DOOR_OAK_PAINTED.id)
+				if (i == Items.DYE.id || i == Items.DOOR_OAK_PAINTED.id || i == Items.SIGN_PAINTED.id)
 				{
 					for (int j = 1; j < 16; j++)
 					{
diff --git a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index d6982dd7b..e833a79df 100644
--- a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -104,9 +104,7 @@ public class ExplosionCannonball extends Explosion{
                 double d12 = worldObj.getSeenPercent(vec3, entity.bb);
                 double d13 = (1.0D - d4) * d12;
                 entity.hurt(exploder, (int)(((d13 * d13 + d13) / 2D) * 8D * (double)explosionSize + 1.0D), DamageType.BLAST);
-                entity.xd += d6 * d13;
-                entity.yd += (d8 * d13) + 0.5F;
-                entity.zd += d10 * d13;
+                entity.fling(d6 * d13, (d8 * d13) + 0.5F, d10 * d13, 1);
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 66a4014c8..0ba9e0f16 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -14,6 +14,7 @@ import java.util.UUID;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 
+import net.minecraft.core.block.BlockLogicOreRedstone;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
@@ -2631,7 +2632,7 @@ public class World implements WorldSource {
 
     public boolean getSignal(int x, int y, int z, Side side) {
         Block<?> block = getBlock(x, y, z);
-        if(isBlockNormalCube(x, y, z) && block != Blocks.BLOCK_REDSTONE && block != Blocks.PUMPKIN_REDSTONE) {
+        if(isBlockNormalCube(x, y, z) && block != Blocks.BLOCK_REDSTONE && !Block.hasLogicClass(block, BlockLogicOreRedstone.class) && block != Blocks.PUMPKIN_REDSTONE) {
             return hasDirectSignal(x, y, z);
         }
         if(block == null) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
index 6c4507283..1ebdfe1ef 100644
--- a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.LightLayer;
@@ -17,6 +18,16 @@ public interface WorldSource
 
     TileEntity getTileEntity(int x, int y, int z);
 
+    default <T> @Nullable T getBlockLogic(final int x, final int y, final int z, final Class<T> logicClass) {
+        final Block<?> block = getBlock(x, y, z);
+        if (block == null) return null;
+        final BlockLogic logic = block.getLogic();
+        if (logicClass.isAssignableFrom(logic.getClass())) {
+            return logicClass.cast(logic);
+        }
+        return null;
+    }
+
     float getBrightness(int x, int y, int z, int blockLightValue);
     
     int getLightmapCoord(int x, int y, int z, int blockLightValue);
diff --git a/game/core/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java b/game/core/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
index 5ccf3447b..6291b81c6 100644
--- a/game/core/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
@@ -256,7 +256,7 @@ public class SynchedEntityData
             case TYPE_STRING:
                 String s = (String)value;
                 dos.write(metadata);
-                Packet.writeString(s, dos);
+                Packet.writeStringUTF8(s, dos);
                 break;
             case TYPE_ITEMSTACK:
                 ItemStack itemStack = (ItemStack)value;
@@ -320,7 +320,7 @@ public class SynchedEntityData
                         di = new DataItem<>(type, id, dis.readFloat());
                         break;
                     case TYPE_STRING:
-                        di = new DataItem<>(type, id, Packet.readString(dis, MAX_STRING_SIZE));
+                        di = new DataItem<>(type, id, Packet.readStringUTF8(dis, MAX_STRING_SIZE));
                         break;
                     case TYPE_ITEMSTACK:
                         short itemId = dis.readShort();
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
index da6e2bc97..0c2586012 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.generate.feature;
 
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -12,7 +13,7 @@ public class WorldFeatureOre extends WorldFeature
 {
     private int minableBlockId;
     private int numberOfBlocks;
-    private final Map<Integer, Integer> variantMap;
+    private final OreMap variantMap;
     @MethodParametersAnnotation(names = {"blockId", "numberOfBlocks"})
     public WorldFeatureOre(int blockId, int numberOfBlocks)
     {
@@ -21,7 +22,7 @@ public class WorldFeatureOre extends WorldFeature
         this.variantMap = null;
     }
     @MethodParametersAnnotation(names = {"blockId", "numberOfBlocks", "variantMap"})
-    public WorldFeatureOre(@NotNull Map<Integer, Integer> variantMap, int numberOfBlocks)
+    public WorldFeatureOre(@NotNull OreMap variantMap, int numberOfBlocks)
     {
         this.numberOfBlocks = numberOfBlocks;
         this.variantMap = variantMap;
@@ -99,4 +100,62 @@ public class WorldFeatureOre extends WorldFeature
 
         return true;
     }
+
+    // Oremap class, created to quickly map ints to ints without having convert them to Integer Objects, size increasing performance isn't too good and should really only be used in cases where a map is created once then almost never expanded
+    public static class OreMap {
+        private int @NotNull [] keyArr = new int[0];
+        private int @NotNull [] valArr = new int[0];
+
+        private static int @NotNull [] increaseArraySize(final int @NotNull [] array) {
+            final int[] outArr = new int[array.length + 1];
+            System.arraycopy(array, 0, outArr, 0, array.length);
+            return outArr;
+        }
+
+
+        public void put(@NotNull final Block<?> stone, @NotNull final Block<?> ore) {
+            put(stone.id(), ore.id());
+        }
+
+        public void put(final int stoneId, final int oreId) {
+            final int index = indexForKey(stoneId);
+            if (index == -1) {
+                this.keyArr = increaseArraySize(this.keyArr);
+                this.keyArr[this.keyArr.length - 1] = stoneId;
+
+                this.valArr = increaseArraySize(this.valArr);
+                this.valArr[this.valArr.length - 1] = oreId;
+            } else {
+                this.valArr[index] = oreId;
+            }
+        }
+
+        public int get(@NotNull final Block<?> stone) {
+            return get(stone.id());
+        }
+
+        public int get(final int stoneId) {
+            final int index = indexForKey(stoneId);
+            if (index == -1) return index;
+            return this.valArr[index];
+        }
+
+        private int indexForKey(final int stoneId) {
+            for (int i = 0; i < this.keyArr.length; i++) {
+                if (this.keyArr[i] == stoneId) return i;
+            }
+            return -1;
+        }
+
+        public boolean containsKey(@NotNull final Block<?> stone) {
+            return containsKey(stone.id());
+        }
+
+        public boolean containsKey(final int stoneId) {
+            for (int i = 0; i < this.keyArr.length; i++) {
+                if (this.keyArr[i] == stoneId) return true;
+            }
+            return false;
+        }
+    }
 }
diff --git a/game/core/src/main/resources/lang/en_US/gui.lang b/game/core/src/main/resources/lang/en_US/gui.lang
index 5a4ee7ac9..07fdc652d 100644
--- a/game/core/src/main/resources/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/lang/en_US/gui.lang
@@ -389,6 +389,7 @@ model.category.entity.boat.button.flag=Flag: %s
 model.category.entity.boat.button.wind=Wind: %s degrees
 model.category.entity.slime.slider.size=Slime: %s
 model.category.entity.minecart.button.cycle=Cycle Minecart
+model.category.entity.minecart.slider.color=Color: %s
 
 model.category.block.name=Block
 model.category.block.info=Block: %s
diff --git a/game/core/src/main/resources/lang/en_US/item.lang b/game/core/src/main/resources/lang/en_US/item.lang
index a8165425c..e57bb67ee 100644
--- a/game/core/src/main/resources/lang/en_US/item.lang
+++ b/game/core/src/main/resources/lang/en_US/item.lang
@@ -166,6 +166,42 @@ item.food.apple.gold.name=Golden Apple
 item.food.apple.gold.desc=Invincible! No fear!
 item.sign.name=Sign
 item.sign.desc=Mark your land, or write a message.
+
+item.sign.painted.name=Painted Sign
+item.sign.painted.desc=How did you get this?!
+item.sign.painted.black.name=Black Sign
+item.sign.painted.black.desc=Mark your land, or write a message.
+item.sign.painted.red.name=Red Sign
+item.sign.painted.red.desc=Mark your land, or write a message.
+item.sign.painted.green.name=Green Sign
+item.sign.painted.green.desc=Mark your land, or write a message.
+item.sign.painted.brown.name=Brown Sign
+item.sign.painted.brown.desc=Mark your land, or write a message.
+item.sign.painted.blue.name=Blue Sign
+item.sign.painted.blue.desc=Mark your land, or write a message.
+item.sign.painted.purple.name=Purple Sign
+item.sign.painted.purple.desc=Mark your land, or write a message.
+item.sign.painted.cyan.name=Cyan Sign
+item.sign.painted.cyan.desc=Mark your land, or write a message.
+item.sign.painted.silver.name=Light Gray Sign
+item.sign.painted.silver.desc=Mark your land, or write a message.
+item.sign.painted.gray.name=Gray Sign
+item.sign.painted.gray.desc=Mark your land, or write a message.
+item.sign.painted.pink.name=Pink Sign
+item.sign.painted.pink.desc=Mark your land, or write a message.
+item.sign.painted.lime.name=Lime Sign
+item.sign.painted.lime.desc=Mark your land, or write a message.
+item.sign.painted.yellow.name=Yellow Sign
+item.sign.painted.yellow.desc=Mark your land, or write a message.
+item.sign.painted.lightblue.name=Light Blue Sign
+item.sign.painted.lightblue.desc=Mark your land, or write a message.
+item.sign.painted.magenta.name=Magenta Sign
+item.sign.painted.magenta.desc=Mark your land, or write a message.
+item.sign.painted.orange.name=Orange Sign
+item.sign.painted.orange.desc=Mark your land, or write a message.
+item.sign.painted.white.name=White Sign
+item.sign.painted.white.desc=Mark your land, or write a message.
+
 item.door.oak.name=Wooden Door
 item.door.oak.desc=Every house needs one.
 item.bucket.name=Bucket
diff --git a/game/core/src/main/resources/lang/en_US/options.lang b/game/core/src/main/resources/lang/en_US/options.lang
index 0ea6f1bf5..f85f82a36 100644
--- a/game/core/src/main/resources/lang/en_US/options.lang
+++ b/game/core/src/main/resources/lang/en_US/options.lang
@@ -258,6 +258,7 @@ key.switchPerspective=Switch Perspective
 key.screenshot=Take Screenshot
 key.cinematicCamera=Toggle Cinematic Camera
 key.autoWalk=Auto Walk
+key.easyBridge=Toggle Easy Bridge
 key.sprint=Sprint (if enabled)
 key.toggleDebug=Toggle Debug
 key.toggleOverlay=Toggle Overlays
diff --git a/game/core/src/main/resources/lang/en_US/strings.lang b/game/core/src/main/resources/lang/en_US/strings.lang
index 10cf51963..1accede2c 100644
--- a/game/core/src/main/resources/lang/en_US/strings.lang
+++ b/game/core/src/main/resources/lang/en_US/strings.lang
@@ -132,6 +132,10 @@ sign.image.craft=Craft
 sign.image.afk=AFK
 sign.image.brb=BRB
 sign.image.heart=Heart
+sign.image.arrows_left_right=Left Right Arrows
+sign.image.arrows_up_down=Up Down Arrows
+sign.image.check=Check
+sign.image.exit=Exit
 
 record.13=13
 record.cat=Cat
diff --git a/game/core/src/main/resources/lang/en_US/tile.lang b/game/core/src/main/resources/lang/en_US/tile.lang
index 378ea87d6..dd9f90954 100644
--- a/game/core/src/main/resources/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/lang/en_US/tile.lang
@@ -833,10 +833,80 @@ tile.crops.pumpkin.desc=A ripening pumpkin, plucked from the ground.
 tile.farmland.dirt.name=Farmland
 tile.farmland.dirt.desc=Tilled soil for growing crops.
 
-tile.sign.post.planks.oak.name=Oak Signpost
-tile.sign.post.planks.oak.desc=A free-standing oak sign.
-tile.sign.wall.planks.oak.name=Oak Wall Sign
-tile.sign.wall.planks.oak.desc=An oak sign placed on a wall.
+tile.sign.post.planks.oak.name=Wooden Signpost
+tile.sign.post.planks.oak.desc=A free-standing wooden sign.
+tile.sign.wall.planks.oak.name=Wooden Wall Sign
+tile.sign.wall.planks.oak.desc=An wooden sign placed on a wall.
+
+tile.sign.wall.planks.oak.painted.name=Mystery Wooden Chest
+tile.sign.wall.planks.oak.painted.desc=How did you get this?!
+tile.sign.wall.planks.oak.painted.black.name=Black Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.black.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.red.name=Red Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.red.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.green.name=Green Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.green.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.brown.name=Brown Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.brown.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.blue.name=Blue Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.blue.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.purple.name=Purple Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.purple.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.cyan.name=Cyan Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.cyan.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.silver.name=Light Gray Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.silver.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.gray.name=Gray Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.gray.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.pink.name=Pink Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.pink.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.lime.name=Lime Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.lime.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.yellow.name=Yellow Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.yellow.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.lightblue.name=Light Blue Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.lightblue.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.magenta.name=Magenta Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.magenta.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.orange.name=Orange Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.orange.desc=An wooden sign placed on a wall.
+tile.sign.wall.planks.oak.painted.white.name=White Wooden Wall Sign
+tile.sign.wall.planks.oak.painted.white.desc=An wooden sign placed on a wall.
+
+tile.sign.post.planks.oak.painted.name=Mystery Wooden Chest
+tile.sign.post.planks.oak.painted.desc=How did you get this?!
+tile.sign.post.planks.oak.painted.black.name=Black Wooden Signpost
+tile.sign.post.planks.oak.painted.black.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.red.name=Red Wooden Signpost
+tile.sign.post.planks.oak.painted.red.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.green.name=Green Wooden Signpost
+tile.sign.post.planks.oak.painted.green.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.brown.name=Brown Wooden Signpost
+tile.sign.post.planks.oak.painted.brown.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.blue.name=Blue Wooden Signpost
+tile.sign.post.planks.oak.painted.blue.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.purple.name=Purple Wooden Signpost
+tile.sign.post.planks.oak.painted.purple.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.cyan.name=Cyan Wooden Signpost
+tile.sign.post.planks.oak.painted.cyan.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.silver.name=Light Gray Wooden Signpost
+tile.sign.post.planks.oak.painted.silver.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.gray.name=Gray Wooden Signpost
+tile.sign.post.planks.oak.painted.gray.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.pink.name=Pink Wooden Signpost
+tile.sign.post.planks.oak.painted.pink.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.lime.name=Lime Wooden Signpost
+tile.sign.post.planks.oak.painted.lime.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.yellow.name=Yellow Wooden Signpost
+tile.sign.post.planks.oak.painted.yellow.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.lightblue.name=Light Blue Wooden Signpost
+tile.sign.post.planks.oak.painted.lightblue.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.magenta.name=Magenta Wooden Signpost
+tile.sign.post.planks.oak.painted.magenta.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.orange.name=Orange Wooden Signpost
+tile.sign.post.planks.oak.painted.orange.desc=A free-standing wooden sign.
+tile.sign.post.planks.oak.painted.white.name=White Wooden Signpost
+tile.sign.post.planks.oak.painted.white.desc=A free-standing wooden sign.
 
 tile.layer.snow.name=Snow Layer
 tile.layer.snow.desc=A flat layer of snow.
diff --git a/game/server/build.gradle.kts b/game/server/build.gradle.kts
index 2d965b857..b527a5cd0 100644
--- a/game/server/build.gradle.kts
+++ b/game/server/build.gradle.kts
@@ -14,6 +14,15 @@ val include: Configuration by configurations.creating
 repositories {
     mavenCentral()
     maven("https://libraries.minecraft.net/")
+
+    ivy {
+        url = uri("https://github.com/Better-than-Adventure")
+        patternLayout {
+            artifact("[organisation]/releases/download/[revision]/brigadier-[revision].jar")
+            m2Compatible
+        }
+        metadataSources { artifact() }
+    }
 }
 
 dependencies {
@@ -30,6 +39,7 @@ dependencies {
     // </core dependencies>
 }
 
+
 java {
     sourceCompatibility = JavaVersion.VERSION_1_8
     targetCompatibility = JavaVersion.VERSION_1_8
diff --git a/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java b/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
index 6cdc9c42f..2d3a259a6 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
@@ -29,7 +29,7 @@ public class ConsoleCommandSource implements CommandSource, IServerCommandSource
     }
 
     @Override
-    public Collection<String> getPlayerNames() {
+    public Collection<String> getPlayerUsernames() {
         List<String> list = new ArrayList<>();
         for (Player player : server.playerList.playerEntities) {
             list.add(player.username);
@@ -37,9 +37,18 @@ public class ConsoleCommandSource implements CommandSource, IServerCommandSource
         return list;
     }
 
+    @Override
+    public Collection<String> getPlayerNicknames() {
+        List<String> list = new ArrayList<>();
+        for (Player player : server.playerList.playerEntities) {
+            list.add(player.nickname);
+        }
+        return list;
+    }
+
     @Override
     public Collection<String> getEntitySuggestions() {
-        return this.getPlayerNames();
+        return this.getPlayerUsernames();
     }
 
     @Override
diff --git a/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java b/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
index 7b041ec01..92053153e 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
@@ -27,7 +27,7 @@ public class ServerCommandSource implements CommandSource, IServerCommandSource
     }
 
     @Override
-    public Collection<String> getPlayerNames() {
+    public Collection<String> getPlayerUsernames() {
         List<String> list = new ArrayList<>();
         for (Player player : server.playerList.playerEntities) {
             list.add(player.username);
@@ -35,9 +35,18 @@ public class ServerCommandSource implements CommandSource, IServerCommandSource
         return list;
     }
 
+    @Override
+    public Collection<String> getPlayerNicknames() {
+        List<String> list = new ArrayList<>();
+        for (Player player : server.playerList.playerEntities) {
+            list.add(player.nickname);
+        }
+        return list;
+    }
+
     @Override
     public Collection<String> getEntitySuggestions() {
-        return this.getPlayerNames();
+        return this.getPlayerUsernames();
     }
 
     @Override
diff --git a/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandBan.java b/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandBan.java
index bb32380bf..ce2f8743c 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandBan.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandBan.java
@@ -2,9 +2,9 @@ package net.minecraft.server.net.command.commands;
 
 import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
-import com.mojang.brigadier.arguments.StringArgumentType;
-import com.mojang.brigadier.builder.LiteralArgumentBuilder;
-import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.arguments.ArgumentTypeString;
+import com.mojang.brigadier.builder.ArgumentBuilderLiteral;
+import com.mojang.brigadier.builder.ArgumentBuilderRequired;
 import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.CommandManager;
@@ -22,10 +22,10 @@ public class CommandBan implements CommandManager.CommandRegistry {
     public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register
         (
-            LiteralArgumentBuilder.<CommandSource>literal("ban")
+            ArgumentBuilderLiteral.<CommandSource>literal("ban")
                 .requires(CommandSource::hasAdmin)
-                .then(LiteralArgumentBuilder.<CommandSource>literal("username")
-                    .then(RequiredArgumentBuilder.<CommandSource, String>argument("name", StringArgumentType.word()).executes(c -> {
+                .then(ArgumentBuilderLiteral.<CommandSource>literal("username")
+                    .then(ArgumentBuilderRequired.<CommandSource, String>argument("name", ArgumentTypeString.word()).executes(c -> {
                         CommandSource source = c.getSource();
                         if (!(source instanceof IServerCommandSource)) throw CommandExceptions.multiplayerWorldOnly().create();
 
@@ -51,8 +51,8 @@ public class CommandBan implements CommandManager.CommandRegistry {
                         }
                         return Command.SINGLE_SUCCESS;
                     })))
-                .then(LiteralArgumentBuilder.<CommandSource>literal("ip")
-                    .then(RequiredArgumentBuilder.<CommandSource, String>argument("address", StringArgumentType.word()).executes(c -> {
+                .then(ArgumentBuilderLiteral.<CommandSource>literal("ip")
+                    .then(ArgumentBuilderRequired.<CommandSource, String>argument("address", ArgumentTypeString.word()).executes(c -> {
                         CommandSource source = c.getSource();
                         if (!(source instanceof IServerCommandSource)) throw CommandExceptions.multiplayerWorldOnly().create();
 
